' showColHeaders, showRowHeaders
' rowHeaderWidth
' frozRows, frozCols
' UserPaint( part as DWord, state as DWord, dta as CellData ): ' header background, header foreground
' row background, cell background, cell foreground
' True if drawn, False if not.  Allow user to change CellDrawData

#If Not %Def(%INCLUDE)
#Compile SLL
#Dim All
#Register All
#EndIf

%UNICODE = 1
#Include "Win32Api.inc"
#Include Once "UxTheme.inc"
#Include Once "VsStyle.inc"
#Include Once "VsSym32.inc"
#Include Once "TableInfo.inc"

$TABLE_CLASS = "lcTable"

Global Table_HasManifest As Long
Global   Table_hTheme As Dword

%Table_PaintTimer = 1001

' Cell Window in a Scrolling WIndow.  Scrolling WIndow in parent window, headers drawn in parent window.
Global tableCount As Long

Function NewTable Alias "NewTable"(ByVal hParent As Long, ByVal pLeft As Long, ByVal pTop As Long, ByVal pWidth As Long, ByVal pHeight As Long, ByVal Id As Long) Export Common As Long
	Local hWnd As Dword
	Call Table_Init()

	hWnd = CreateWindowEx( 0, $TABLE_CLASS, "", %WS_Child Or %WS_Visible Or %WS_TabStop, pLeft, pTop, pWidth, pHeight, hParent, Id, GetModuleHandle( ByVal 0), ByVal 0 )
	Function = hWnd
End Function

Sub Table_SetAllowResize( ByVal hWnd As Dword, ByVal allow As Long ) Common Export
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	@pTableData.allowResize = IIf&( allow, -1, 0 )
End Sub

Sub Table_SetSelectKey( ByVal hWnd As Dword, ByVal vkKey As Dword ) Common Export
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	@pTableData.selectKey = vkKey
End Sub

Sub Table_SetUserPaint( ByVal hWnd As Dword, ByVal procedure As Dword ) Common Export
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	@pTableData.userPaint = procedure
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetHeaders( ByVal hWnd As Dword, ByVal showColHeaders As Long, ByVal showRowHeaders As Long, ByVal rowHeaderWidth As Long ) Common Export
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.showColHeaders = IIf&( showColHeaders, -1, 0 )
	@pTableData.showRowHeaders = IIf&( showRowHeaders, -1, 0 )
	If rowHeaderWidth>0 Then @pTableData.rowHeaderWidth = rowHeaderWidth
	Local rc As RECT
	GetClientRect( hWnd, rc )
	Table_OnSize( hWnd, rc.right, rc.bottom ): ' Adjust scroll bars
End Sub

Sub Table_SetFrozen( ByVal hWnd As Dword, ByVal rows As Long, ByVal cols As Long, ByVal clr As Dword ) Export Common
	Local pTableData As TableData Ptr
	Local rc As RECT

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	If rows>-1 Then @pTableData.frozRows = rows
	If cols>-1 Then @pTableData.frozCols = cols
	If clr>0 Then  @pTableData.frozColor = clr

	@pTableData.sysFrozColor = IIf&( @pTableData.frozColor = GetSysColor( %COLOR_INFOBK ), -1, 0 )

	@pTableData.topRow  = Max&( rows, @pTableData.topRow)
	@pTableData.leftCol = Max&( cols, @pTableData.leftCol)
	GetClientRect( hWnd, rc )
	Table_OnSize hWnd, rc.Right, rc.Bottom
End Sub

Sub Table_SetDataSource2( ByVal hWnd As Dword, ByVal getData As Dword, ByVal setData As Dword, ByVal rows As Integer, ByVal cols As Integer ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	@pTableData.ds.getData = getData
	@pTableData.ds.setData = setData
	@pTableData.rows = rows
	Call Table_SetColumns( hWnd, cols )
	Table_Goto( hWnd, 0, 0 )

	Local rc As RECT
	GetClientRect( hWnd, rc )
	Table_OnSize( hWnd, rc.right, rc.bottom )
End Sub

Sub Table_SetDataSource( ByVal hWnd As Dword, ByRef ds As DataSource ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	@pTableData.ds.getData = ds.getData
	@pTableData.ds.setData = ds.setData

	Table_Goto( hWnd, 0, 0 )
	Local rc As RECT
	GetClientRect( hWnd, rc )
	Table_OnSize( hWnd, rc.right, rc.bottom )
End Sub

Sub Table_SetStyle( ByVal hWnd As Dword, ByVal colHeaderStyle As Long, ByVal rowHeaderStyle As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.colHeaderStyle = colHeaderStyle
	@pTableData.rowHeaderStyle = rowHeaderStyle
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetRows( ByVal hWnd As Dword, ByVal value As Long ) Export Common
	Local pTableData As TableData Ptr
	Local rc As RECT
	If value<1 Then Exit Sub
	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.rows = value
	GetClientRect( hWnd, rc )
	@pTableData.topRow = @pTableData.frozRows
	@pTableData.leftCol = @pTableData.frozCols
	Table_OnSize( hWnd, rc.Right, rc.Bottom )
End Sub

Sub Table_SetCols( ByVal hWnd As Dword, ByVal value As Long ) Export Common
	Local pTableData As TableData Ptr
	Local rc As RECT

	If value<1 Then Exit Sub
	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	Call Table_SetColumns( hWnd, value )
	GetClientRect( hWnd, rc )
	Table_Goto( hWnd, 0, 0 )
	@pTableData.topRow = @pTableData.frozRows
	@pTableData.leftCol = @pTableData.frozCols
	Table_OnSize( hWnd, rc.Right, rc.Bottom )
End Sub

Sub Table_SetCol( ByVal hWnd As Dword, ByVal c As Long, ByVal w As Long, ByVal align As Dword, ByVal foreColor As Dword, ByVal backColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	If c>=0 And c<@pTableData.cols Then
		@pTableData.@Column[c].Width = w
		@pTableData.@Column[c].align = align
		@pTableData.@Column[c].foreColor = foreColor
		@pTableData.@Column[c].backColor = backColor
	End If
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetPos( ByVal hWnd As Dword, ByVal r As Long, ByVal c As Long ) Export Common
	Table_Goto( hWnd, r, c )
End Sub

Sub Table_SetSelectRow( ByVal hWnd As Dword, ByVal selRow As Long, ByVal ht As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.selectRow = IIf&( selRow, -1, 0 )
	@pTableData.hotTrack = IIf&( ht, -1, 0 )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetTablelines( ByVal hWnd As Dword, ByVal showHoriz As Long, ByVal showVert As Long, ByVal gridColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.horizontalGrid = IIf&(showHoriz,-1,0)
	@pTableData.verticalGrid = IIf&(showVert,-1,0)
	If gridColor>0 Then @pTableData.gridColor = gridColor
	@pTableData.sysGridColor = IIf&(@pTableData.gridColor = GetSysColor( %COLOR_ACTIVEBORDER ), -1, 0 )

	Local rc As RECT
	GetClientRect( hWnd, rc )
	Table_OnSize( hWnd, rc.right, rc.bottom )
End Sub

Sub Table_SetRowHeight( ByVal hWnd As Dword, ByVal value As Long ) Export Common
	Local pTableData As TableData Ptr
	If value<1 Then Exit Sub
	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.rowHeight = value

	Local rc As RECT
	GetClientRect( hWnd, rc )
	Table_OnSize( hWnd, rc.right, rc.bottom )
End Sub

Sub Table_SetForeColor( ByVal hWnd As Dword, ByVal value As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	If value>0 Then @pTableData.foreColor = value
	@pTableData.sysForeColor = IIf&(@pTableData.foreColor = GetSysColor( %COLOR_WINDOWTEXT ), -1, 0 )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetBackColor( ByVal hWnd As Dword, ByVal value As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	If value>0 Then @pTableData.backColor = value
	@pTableData.sysBackColor = IIf&(@pTableData.backColor = GetSysColor( %COLOR_WINDOW ), -1, 0 )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetAlternatingRows( ByVal hWnd As Dword, ByVal value As Long, ByVal c As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.alternateRows = IIf&(value, -1, 0 )
	If c>0 Then @pTableData.altBack = c
	@pTableData.sysAltBack = IIf&(@pTableData.altBack = GetSysColor( %COLOR_INFOBK ), -1, 0 )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetWorkspaceColor( ByVal hWnd As Dword, ByVal value As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	If value>0 Then @pTableData.workspaceColor = value
	@pTableData.sysWorkspaceColor = IIf&(@pTableData.workspaceColor = GetSysColor( %COLOR_APPWORKSPACE ), -1, 0 )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetSelectColors( ByVal hWnd As Dword, ByVal color1 As Dword, ByVal color2 As Dword, ByVal borderColor As Dword, ByVal textColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	If color1 >0    Then @pTableData.selColor1 = color1
	If color2 >0    Then @pTableData.selColor2 = color2
	If textColor >0 Then @pTableData.selBColor = borderColor
	If color1 >0    Then @pTableData.selTColor = textColor
	@pTableData.sysSelColor1 = IIf&(@pTableData.selColor1 = GetSysColor( %COLOR_GRADIENTACTIVECAPTION ), -1, 0 )
	@pTableData.sysSelColor2 = IIf&(@pTableData.selColor2 = GetSysColor( %COLOR_ACTIVECAPTION ), -1, 0 )
	@pTableData.sysSelBColor = IIf&(@pTableData.selBColor = GetSysColor( %COLOR_ACTIVECAPTION ), -1, 0 )
	@pTableData.sysSelTColor = IIf&(@pTableData.selTColor = GetSysColor( %COLOR_CAPTIONTEXT ), -1, 0 )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_SetHotColors( ByVal hWnd As Dword, ByVal color1 As Dword, ByVal color2 As Dword, ByVal borderColor As Dword, ByVal textColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0   Then Exit Sub
	If color2 >0      Then @pTableData.hotColor1 = color1
	If color1 >0      Then @pTableData.hotColor2 = color2
	If borderColor >0 Then @pTableData.hotBColor = borderColor
	If textColor >0   Then @pTableData.hotTColor = textColor
	@pTableData.sysHotColor1 = IIf&(@pTableData.hotColor1 = GetSysColor( %COLOR_GRADIENTINACTIVECAPTION ), -1, 0): ' Light gradient, -1, 0 )
	@pTableData.sysHotColor2 = IIf&(@pTableData.hotColor2 = GetSysColor( %COLOR_INACTIVECAPTION ), -1, 0): ' Dark gradient, -1, 0 )
	@pTableData.sysHotBColor = IIf&(@pTableData.hotBColor = GetSysColor( %COLOR_GRADIENTACTIVECAPTION ), -1, 0): ' Border Color, -1, 0 )
	@pTableData.sysHotTColor = IIf&(@pTableData.hotTColor = GetSysColor( %COLOR_INACTIVECAPTIONTEXT ), -1, 0): ' Text color, -1, 0 )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub


Sub Table_GetAllowResize( ByVal hWnd As Dword, ByRef allow As Long ) Common Export
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	allow = @pTableData.allowResize
End Sub

Sub Table_GetSelectKey( ByVal hWnd As Dword, ByRef vkKey As Dword ) Common Export
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	vkKey = @pTableData.selectKey
End Sub

Sub Table_GetHeaders( ByVal hWnd As Dword, ByRef showColHeaders As Long, ByRef showRowHeaders As Long, ByRef rowHeaderWidth As Long ) Common Export
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	showColHeaders = @pTableData.showColHeaders
	showRowHeaders = @pTableData.showRowHeaders
	rowHeaderWidth = @pTableData.rowHeaderWidth
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_GetFrozen( ByVal hWnd As Dword, ByRef rows As Long, ByRef cols As Long, ByRef clr As Dword ) Export Common
	Local pTableData As TableData Ptr
	Local rc As RECT

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	rows = @pTableData.frozRows
	cols = @pTableData.frozCols
	clr  = @pTableData.frozColor
End Sub

Sub Table_GetDataSource( ByVal hWnd As Dword, ByRef ds As DataSource ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	ds.GetData = @pTableData.ds.GetData
	ds.SetData = @pTableData.ds.SetData
End Sub

Sub Table_GetStyle( ByVal hWnd As Dword, ByRef colStyle As Long, ByRef rowStyle As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	colStyle = @pTableData.colHeaderStyle
	rowStyle = @pTableData.rowHeaderStyle
End Sub

Sub Table_GetRows( ByVal hWnd As Dword, ByRef value As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	value = @pTableData.rows
End Sub

Sub Table_GetCols( ByVal hWnd As Dword, ByRef value As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	value = @pTableData.cols
End Sub

Sub Table_GetCol( ByVal hWnd As Dword, ByVal c As Long, ByRef w As Long, ByRef align As Dword, ByRef foreColor As Dword, backColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	w = @pTableData.@Column[c].Width
	align = @pTableData.@Column[c].align
	foreColor = @pTableData.@Column[c].foreColor
	backColor = @pTableData.@Column[c].backColor
End Sub

Sub Table_GetPos( ByVal hWnd As Dword, ByRef r As Long, ByRef c As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	r = @pTableData.curRow
	c = @pTableData.curCol
End Sub

Sub Table_GetSelectRow( ByVal hWnd As Dword, ByRef selRow As Long, ByRef ht As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	selRow = @pTableData.selectRow
	ht = @pTableData.hotTrack
End Sub

Sub Table_GetTable( ByVal hWnd As Dword, ByRef showHoriz As Long, ByRef showVert As Long, ByRef gridColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	showHoriz = @pTableData.horizontalGrid
	showVert = @pTableData.verticalGrid
	gridColor = @pTableData.gridColor
End Sub

Sub Table_GetRowHeight( ByVal hWnd As Dword, ByRef value As Long ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	value = @pTableData.rowHeight
End Sub

Sub Table_GetForeColor( ByVal hWnd As Dword, ByRef value As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	value = @pTableData.forecolor
End Sub

Sub Table_GetBackColor( ByVal hWnd As Dword, ByRef value As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	value = @pTableData.backColor
End Sub

Sub Table_GetAlternatingRows( ByVal hWnd As Dword, ByRef value As Long, ByRef c As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	value = @pTableData.alternateRows
	c = @pTableData.altBack
End Sub

Sub Table_GetWorkspaceColor( ByVal hWnd As Dword, ByRef value As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	value = @pTableData.workspaceColor
End Sub

Sub Table_GetSelectColors( ByVal hWnd As Dword, ByRef color1 As Dword, ByRef color2 As Dword, ByRef borderColor As Dword, ByRef textColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	color1      = @pTableData.selColor1
	color2      = @pTableData.selColor2
	borderColor = @pTableData.selBColor
	textColor   = @pTableData.selTColor
End Sub
Sub Table_GetHotColors( ByVal hWnd As Dword, ByRef color1 As Dword, ByRef color2 As Dword, ByRef borderColor As Dword, ByRef textColor As Dword ) Export Common
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	color1      = @pTableData.hotColor1
	color2      = @pTableData.hotColor2
	borderColor = @pTableData.hotBColor
	textColor   = @pTableData.hotTColor
End Sub

Function Table_ControlProc( ByVal hWnd As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long
	Static ret As Long
	Function = 0

	Select Case Const wMsg
		Case %WM_THEMECHANGED:    Call Table_OnThemeChanged( hWnd )
		Case %WM_Timer:           Call Table_OnTimer( hWnd, wParam )
		Case %WM_NCCreate:        Call Table_OnCreate( hWnd )
		Case %WM_Destroy:         Call Table_OnDestroy( hWnd )
		Case %WM_GetDlgCode:      Function = Table_OnDlgCode( lParam ): Exit Function
		Case %WM_KeyDown:         Call Table_OnKeyDown( hWnd, wParam ): Exit Function
		Case %WM_Char:            Exit Function
		Case %WM_MouseActivate:   Function = Table_OnActivate( hWnd, Mak(Dword, %WA_ACTIVE, 0 )): Exit Function
		Case %WM_Activate:        Call Table_OnActivate( hWnd, wParam ): Exit Function
		Case %WM_MouseWheel:      Call Table_OnMouseWheel( hWnd, wParam ):   Exit Function
		Case %WM_Size:            Call Table_OnSize( hWnd, Lo(Word, lParam), Hi(Word, lParam) ): Exit Function
		Case %WM_HScroll:         Call Table_OnHScroll( hWnd, wParam ): Exit Function
		Case %WM_VScroll:         Call Table_OnVScroll( hWnd, wParam ): Exit Function
		Case %WM_Paint:           Call Table_OnPaint( hWnd )
		Case %WM_EraseBkGnd:      Function = Table_OnDrawBackground( hWnd, wParam ): Exit Function
		Case %WM_MouseMove:       Call Table_OnMouseMove( hWnd, Lo(Word, lParam), Hi(Word, lParam)  )
		Case %WM_LButtonDown:     Call Table_OnClick( hWnd, Lo(Word, lParam), Hi(Word, lParam) )
		Case %WM_LButtonUp:       Call Table_OnMouseUp( hWnd, Lo(Word, lParam), Hi(Word, lParam) )
		Case %WM_LButtonDblClk:   Call Table_OnDoubleClick( hWnd ): Exit Function
		Case %WM_SysColorChange:  Call Table_OnSysColorChange( hWnd ): Exit Function
	End Select
	Function = DefWindowProc( hWnd, wMsg, wParam, lParam )
End Function

Sub Table_OnDoubleClick( ByVal hWnd As Long )
	Local p As TableData Ptr
	Local msg As TblNotify

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	msg.hdr.code = %TBN_Select
	msg.hdr.idFrom = GetDlgCtrlID( hWnd )
	msg.hdr.hwndFrom = hWnd
	msg.r = @p.curRow
	msg.c = @p.curCol
	msg.dta = p

	SendMessage( GetParent(hWnd), %WM_Notify, hWnd, VarPtr(msg)  )
End Sub

Sub Table_OnTimer( ByVal hWnd As Long, ByVal timerId As Long )
	Local p As TableData Ptr
	Local cursor As PointAPI
	Local rc As RECT

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	If timerId = %Table_PaintTimer Then
		GetCursorPos(cursor)
		MapWindowPoints( %NULL, hWnd, VarPtr(cursor), 1 )
		GetClientRect( hWnd, rc )
		If cursor.x<rc.Left Or cursor.x>rc.Right Or cursor.y<rc.top Or cursor.y>rc.bottom Then
			InvalidateRect( hWnd, ByVal %NULL, 0 )
			KillTimer( hWnd, %Table_PaintTimer )
		End If
	End If

End Sub

Sub Table_OnSysColorChange( ByVal hWnd As Dword )
	Local p As TableData Ptr

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	If @p.sysGridColor Then
		@p.gridColor = GetSysColor( %COLOR_ACTIVEBORDER )
	End If
	If @p.sysWorkspaceColor Then
		@p.workspaceColor = GetSysColor( %COLOR_APPWORKSPACE )
	End If
	If @p.sysForeColor Then
		@p.foreColor = GetSysColor( %COLOR_WINDOWTEXT )
	End If
	If @p.sysBackColor Then
		@p.backColor = GetSysColor( %COLOR_WINDOW )
	End If
	If @p.sysAltBack Then
		@p.altBack = GetSysColor( %COLOR_INFOBK )
	End If
	If @p.sysSelColor1 Then
		@p.selColor1 = GetSysColor( %COLOR_GRADIENTACTIVECAPTION )
	End If
	If @p.sysSelColor2 Then
		@p.selColor2 = GetSysColor( %COLOR_ACTIVECAPTION )
	End If
	If @p.sysSelBColor Then
		@p.selBColor = GetSysColor( %COLOR_ACTIVECAPTION )
	End If
	If @p.sysSelTColor Then
		@p.selTColor = GetSysColor( %COLOR_CAPTIONTEXT )
	End If
	If @p.sysHotColor1 Then
		@p.hotColor1 = GetSysColor( %COLOR_GRADIENTINACTIVECAPTION )
	End If
	If @p.sysHotColor2 Then
		@p.hotColor2 = GetSysColor( %COLOR_INACTIVECAPTION )
	End If
	If @p.sysHotBColor Then
		@p.hotBColor = GetSysColor( %COLOR_GRADIENTACTIVECAPTION )
	End If
	If @p.sysHotTColor Then
		@p.hotTColor = GetSysColor( %COLOR_INACTIVECAPTIONTEXT )
	End If
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Function Table_OnActivate( ByVal hWnd As Dword, ByVal wParam As Long ) As Long
	If Lo(Word, wParam) <> %WA_INACTIVE Then SetFocus( hWnd )
	Function = %MA_ACTIVATE
End Function

Sub Table_OnSize( ByVal hWnd As Dword, ByVal newClientWidth As Long, ByVal newClientHeight As Long )
	Local si As SCROLLINFO
	Local rc As RECT
	Local x As Long, y As Long
	Local xPageSize As Long
	Local yPageSize As Long
	Local pTableData As TableData Ptr
	Local w As Long
	Local i As Long
	Local c As Long

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub

	si.cbSize = SizeOf(si)
	si.fMask = %SIF_All: '%SIF_Range Or %SIF_Page Or %SIF_Pos

	w = 0
	c = 0
	If @pTableData.showRowHeaders Then
		w += @pTableData.rowHeaderWidth
	End If
	For i=0 To @pTableData.frozCols-1
		y = @pTableData.@Column[i].Width
		If w+y>newClientWidth Then Exit For
		w += y
	Next
	For i=@pTableData.cols-1 To 0 Step -1
		y = @pTableData.@Column[i].Width
		If w+y>newClientWidth Then Exit For
		Incr c
		w += y
	Next
	If c<1 Then c=1

	GetScrollInfo(hWnd, %SB_Horz, si)
	si.nMin = @pTableData.frozCols
	si.nMax = @pTableData.cols - 1
	si.nPage = c
	SetScrollInfo(hWnd, %SB_Horz, si, %TRUE)
	GetScrollInfo(hWnd, %SB_Horz, si)
	@pTableData.leftCol = si.nPos

	yPageSize = newClientHeight \ (@pTableData.rowHeight + IIf&(@pTableData.horizontalGrid,1,0))
	yPageSize -= IIf&(@pTableData.showColHeaders,1,0)
	yPageSize -= @pTableData.frozRows: ' # of scrollable rows
	GetScrollInfo(hWnd, %SB_Vert, si)
	si.nMin = @pTableData.frozRows
	si.nMax = @pTableData.rows - 1
	si.nPage = yPageSize
	SetScrollInfo(hWnd, %SB_Vert, si, %TRUE)
	GetScrollInfo(hWnd, %SB_Vert, si)
	@pTableData.topRow = si.nPos
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_OnHScroll( ByVal hWnd As Dword, ByVal wParam As Dword )
	Local x As Long
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.leftCol = Table_OnScroll( hWnd, %SB_Horz, wParam )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub Table_OnVScroll( ByVal hWnd As Dword, ByVal wParam As Dword )
	Local pTableData As TableData Ptr

	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Sub
	@pTableData.topRow = Table_OnScroll( hWnd, %SB_Vert, wParam )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Function Table_OnScroll( ByVal hWnd As Dword, ByVal pDirection As Long, ByVal scrollType As Long ) As Long
	Local si As SCROLLINFO
	Local rc As RECT
	Local i As Long
	Local w As Long
	Local pTableData As TableData Ptr

	Function = 0
	pTableData = Table_GetInternalData( hWnd )
	If pTableData=0 Then Exit Function

	si.cbSize = SizeOf(si)
	si.fMask = %SIF_All
	GetScrollInfo(hWnd, pDirection, si)
	Select Case LoWrd(scrollType)
		Case %SB_Top:        si.nPos = si.nMin
		Case %SB_Bottom:     si.nPos = si.nMax
		Case %SB_LineUp:     Decr si.nPos
		Case %SB_LineDown:   Incr si.nPos
		Case %SB_PageUp:     si.nPos -= si.nPage
		Case %SB_PageDown:   si.nPos += si.nPage
		Case %SB_ThumbTrack: si.nPos = si.nTrackPos
	End Select
	SetScrollPos( hWnd, pDirection, si.nPos, %TRUE)
	Function = GetScrollPos( hWnd, pDirection )
End Function

Sub Table_ScrollTo( ByVal hWnd As Dword, ByVal r As Long, ByVal c As Long )
	SetScrollPos( hWnd, %SB_Vert, r, %TRUE )
	SetScrollPos( hWnd, %SB_Horz, c, %TRUE )
End Sub

Sub Table_OnMouseWheel( ByVal hWnd As Dword, ByVal wParam As Dword )
	Local dir As Dword

	If GetFocus()<>hWnd Then Exit Sub
	dir = IIf&( Hi( Integer, wParam ) < 0, %SB_PageDown, %SB_PageUp )

	If (Lo(Word, wParam) And %MK_CONTROL)<>0 Then
		Call Table_OnHScroll( hWnd, dir )
	Else
		Call Table_OnVScroll( hWnd, dir )
	End If
End Sub

Function Table_OnDlgCode( ByVal ptmsg As tagMSG Ptr ) As Long
	' Adapted from code by Dominic Mitchel
	' http://www.powerbasic.com/support/pbforums/showthread.php?t=47631&page=6
	Local ret As Long
	Function = 0
	If IsFalse ptmsg Then Exit Function
	' This control will process arrow keys and characters
	ret = %DlgC_WantArrows Or %DlgC_WantChars
	If @ptmsg.message = %WM_KeyDown Then
		' It will also process the Insert and Delete keys
		If (@ptmsg.wParam = %VK_RETURN) Or (@ptmsg.wParam = %VK_INSERT) Or (@ptmsg.wParam = %VK_DELETE) Then
			ret Or= %DlgC_WantAllKeys
		End If
	End If
	Function = ret
End Function

Sub Table_OnKeyDown( ByVal hWnd As Dword, ByVal vkey As Dword )
	Local p As TableData Ptr
	Local si As SCROLLINFO
	Local sk As ShiftKeys
	Local i As Long
	Local v As Long
	Local rc As RECT
	Local r As Long
	Local c As Long

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	If vKey = @p.selectKey Then
		Call Table_OnDoubleClick( hWnd )
		Exit Sub
	End If

	Call GetShifts( sk )
	r = @p.curRow
	c = @p.curCol

	Select Case vKey
		Case %VK_LEFT:
			If sk.isCtrl And Not (sk.isAlt Or sk.isShift) Then
				si.cbSize = SizeOf(si)
				si.fMask  = %SIF_All
				GetScrollInfo(hWnd, %SB_Horz, si)
				c -= (si.nPage-2)
			ElseIf Not (sk.isCtrl Or sk.isAlt Or sk.isShift) Then
				Decr c
			Else
				Exit Sub
			End If
		Case %VK_RIGHT:
			If sk.isCtrl And Not (sk.isAlt Or sk.isShift) Then
				si.cbSize = SizeOf(si)
				si.fMask  = %SIF_All
				GetScrollInfo(hWnd, %SB_Horz, si)
				c += (si.nPage-2)
			ElseIf Not (sk.isCtrl Or sk.isAlt Or sk.isShift) Then
				Incr c
			Else
				Exit Sub
			End If
		Case %VK_UP:
			If Not (sk.isCtrl Or sk.isAlt Or sk.isShift) Then
				Decr r
			Else
				Exit Sub
			End If
		Case %VK_DOWN:
			If Not (sk.isCtrl Or sk.isAlt Or sk.isShift) Then
				Incr r
			Else
				Exit Sub
			End If
		Case %VK_END:
			If Not (sk.isCtrl Or sk.isAlt Or sk.isShift) Then
				c = @p.cols-1
			ElseIf sk.isCtrl And Not (sk.isAlt Or sk.isShift) Then
				c = @p.cols-1
				r = @p.rows-1
			Else
				Exit Sub
			End If
		Case %VK_HOME
			If Not (sk.isCtrl Or sk.isAlt Or sk.isShift) Then
				c = 0
			ElseIf sk.isCtrl And Not (sk.isAlt Or sk.isShift) And (r Or c) Then
				c = 0
				r = 0
			Else
				Exit Sub
			End If
		Case %VK_PRIOR
			si.cbSize = SizeOf(si)
			si.fMask  = %SIF_All
			GetScrollInfo(hWnd, %SB_Vert, si)
			r -= (si.nPage-2)
		Case %VK_NEXT
			si.cbSize = SizeOf(si)
			si.fMask  = %SIF_All
			GetScrollInfo(hWnd, %SB_Vert, si)
			r += (si.nPage-2)
		Case Else
			Exit Sub
	End Select
	Table_Goto( hWnd, r, c )
End Sub

Sub Table_Goto( ByVal hWnd As Dword, ByVal r As Long, ByVal c As Long )
	Local msg As TblNotify
	Local p As TableData Ptr
	Local rc As RECT
	Local v As Long
	Local i As Long
	Local w As Long

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	r = Max( 0, Min( @p.rows-1, r ) )
	c = Max( 0, Min( @p.cols-1, c ) )

	' Adjust left col if needed
	GetClientRect( hWnd, rc )
	If @p.leftCol > c Then
		@p.leftCol = Max&(c, @p.frozCols)
	Else
		v = 0
		w = rc.Right - rc.Left
		If @p.showRowHeaders Then
			v += @p.rowHeaderWidth: ' Skip header
		End If
		If v < w Then
			For i=0 To @p.frozCols-1
				v += @p.@Column[i].Width: ' Skip frozen cells
				If v > rc.Right-rc.Left Then Exit For
			Next
		End If
		If v < w Then
			For i=c To @p.leftCol Step -1
				v += @p.@Column[i].Width
				If v > rc.Right-rc.Left Then Exit For
			Next
			Incr i
			If @p.leftCol < i Then
				@p.leftCol = i
			End If
		End If
	End If

	' Adjust top row if needed
	If @p.topRow > r Then
		@p.topRow = Max(r, @p.frozRows)
	Else
		v = r - (rc.Bottom - rc.Top) \ (@p.rowHeight + IIf&(@p.horizontalGrid,1,0) ) + 1 + IIf&(@p.showColHeaders,1,0)
		If @p.topRow < v Then @p.topRow = v
	End If

	@p.leftCol = Max( @p.frozCols, Min( @p.cols-1, @p.leftCol ) )
	@p.topRow = Max( @p.frozRows, Min( @p.rows-1, @p.topRow ) )
	i = IIf&(@p.curRow<>r Or @p.curCol<>c, -1, 0 )
	@p.curRow = r
	@p.curCol = c

	Call Table_ScrollTo( hWnd, r, c )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
	If i Then
		msg.hdr.code = %TBN_CellChg
		msg.hdr.idFrom = GetDlgCtrlID( hWnd )
		msg.hdr.hwndFrom = hWnd
		msg.r = @p.curRow
		msg.c = @p.curCol
		msg.dta = p

		SendMessage( GetParent(hWnd), %WM_Notify, hWnd, VarPtr(msg)  )
	End If
End Sub

Sub Table_OnMouseUp( ByVal hWnd As Dword, ByVal x As Long, ByVal y As Long )
	Local p As TableData Ptr

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	If @p.sizing Then
		@p.sizing = 0
		ReleaseCapture()
		If @p.sizeCol=-1 Then
			@p.rowHeaderWidth = Max&( 1, x - @p.sizeLeft )
		ElseIf @p.sizeCol>-1 Then
			@p.@Column[@p.sizeCol].Width = Max&(1, x - @p.sizeLeft )
		End If
		InvalidateRect( hWnd, ByVal %NULL, 0 )
		Exit Sub
	End If
End Sub

Sub Table_OnClick( ByVal hWnd As Dword, ByVal x As Long, ByVal y As Long )
	Local p As TableData Ptr
	Local cx As Long
	Local cy As Long
	Local r As Long
	Local c As Long
	Local w As Long
	Local h As Long
	Local wr As Long
	Local wc As Long
	Local vc() As Long
	Local rc As RECT
	Local vcc As Long
	Local vci As Long
	Local vr() As Long
	Local vrc As Long
	Local vri As Long
	Dim vc(200)
	Dim vr(200)

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	GetClientRect( hWnd, rc )
	If @p.sizeCol>-2 Then
		@p.sizePos = x
		SetCapture( hWnd )
		@p.sizing = -1
		Exit Sub
	End If
	Call Table_GetVisCols( p, vc(), vcc, rc, 0 )
	Call Table_GetVisRows( p, vr(), vrc, rc )
	wr = @p.curRow
	wc = @p.curCol

	cx = 0
	If @p.showRowHeaders Then
		cx += @p.rowHeaderWidth
	End If
	For vci = 0 To vcc-1
		c = vc(vci)
		w = IIf&( c<0, @p.rowHeaderWidth, @p.@Column[c].Width ) + IIf&( @p.verticalGrid, 1, 0 )
		If x>=cx And x<=cx+w Then
			wc = c
			Exit For
		End If
		cx += w
	Next

	cy = 0
	If @p.showColHeaders Then
		cy += @p.rowHeight
		If @p.horizontalGrid Then Incr cy
	End If
	For vri=0 To vrc-1
		r = vr(vri)
		h = @p.rowHeight + IIf&( @p.horizontalGrid, 1, 0 )
		If y>=cy And y<=cy+h Then
			wr = r
			Exit For
		End If
		cy += h
	Next
	InvalidateRect( hWnd, ByVal %NULL, 0 )
	Table_Goto( hWnd, wr, wc )
End Sub

Sub Table_OnMouseMove( ByVal hWnd As Dword, ByVal x As Long, ByVal y As Long )
	Local p As TableData Ptr
	Local c As Long
	Local a As Long
	Local w As Long
	Local vcc As Long
	Local vci As Long
	Local rc As RECT
	Dim vc(200) As Long

	p = Table_GetInternalData( hWnd )
	If p=0 Then Exit Sub

	If @p.hotTrack Then InvalidateRect( hWnd, ByVal %NULL, 0 )
	If @p.sizing Then
		If @p.sizeCol=-1 Then
			@p.rowHeaderWidth = Max&( 10, x - @p.sizeLeft )
		ElseIf @p.sizeCol>-1 Then
			@p.@Column[@p.sizeCol].Width = Max&(10, x - @p.sizeLeft )
		End If
		InvalidateRect( hWnd, ByVal %NULL, 0 )
		Exit Sub
	End If

	If y<0 Or y>@p.rowHeight Or @p.showColHeaders=0 Or IsFalse @p.allowResize Then
		SetClassLong( hWnd, %GCL_HCURSOR, @p.hNorm )
		@p.sizeCol = -2
		Exit Sub
	End If

	GetClientRect( hWnd, rc )
	Call Table_GetVisCols( p, vc(), vcc, rc, -1 )
	For vci = 0 To vcc-1
		c = vc(vci)
		w = IIf&(c<0, @p.rowHeaderWidth, @p.@Column[c].Width ) + IIf&( @p.verticalGrid,1,0)
		a += w
		If Abs(x-a)<4 Then
			@p.sizeCol = c
			@p.sizeLeft = a-w
			SetClassLong( hWnd, %GCL_HCURSOR, @p.hSize )
			Exit Sub
		End If
		If x < a Then Exit For
	Next
	@p.sizeCol = -2
	SetClassLong( hWnd, %GCL_HCURSOR, @p.hNorm )
End Sub

Function Table_OnDrawBackground( ByVal hWnd As Dword, ByVal pRet As Long ) As Long
	Function = 0
End Function

Sub Table_GetData( ByVal r As Long, ByVal c As Long, ByRef value As WString )
End Sub

Function Table_PaintSample( ByVal part As Long, ByVal drwState As Long, ByRef value As WString, ByRef dta As DrawCellData ) As Long
End Function

Sub Table_SetBasic( ByVal hWnd As Dword, ByVal hdc As Dword, ByRef cursor As PointAPI, ByVal p As TableData Ptr, ByRef cellData As DrawCellData )
	cellData.hWnd      = hWnd
	cellData.hdc       = hdc
	cellData.selectRow = @p.selectRow
	cellData.table      = p
	cellData.cursor.x  = cursor.x
	cellData.cursor.y  = cursor.y
	cellData.hFont = @p.hTextFont

	cellData.backColor = @p.backColor
	cellData.foreColor = @p.foreColor
	cellData.altBack = @p.altBack

	cellData.selColor1 = @p.selColor1
	cellData.selColor2 = @p.selColor2
	cellData.selBColor = @p.selBColor
	cellData.selTColor = @p.selTColor
	cellData.hotColor1 = @p.hotColor1
	cellData.hotColor2 = @p.hotColor2
	cellData.hotBColor = @p.hotBColor
	cellData.hotTColor = @p.hotTColor
End Sub

Function Table_OnPaint( ByVal hWnd As Dword ) As Long
	Local rc As RECT
	Local hdc As Long
	Local ps As PAINTSTRUCT
	Local p As TableData Ptr
	Local cursor As Point
	Local mhdc As Long
	Local rowWidth As Long
	Local r As Long
	Local c As Long
	Local x As Long
	Local w As Long
	Local startx As Long
	Local y As Long
	Local t As Long
	Local rt As Long: ' Right
	Local bt As Long: ' Bottom
	Local bbr As Long: ' Back brush
	Local br As Dword
	Local gpn As Long: ' Table pen
	Local opn As Long: ' Original pen
	Local obr As Long
	Local hState As Long: ' Header state (HOT, PUSHED, ...)
	Local bc As Long: ' Back color
	Local value As WString
	Local drawStyle As Long
	Local backColor As Dword
	Local foreColor As Dword
	Local cellData As DrawCellData
	Local cc As CCOver
	Local vc() As Long
	Local vcc As Long
	Local vr() As Long
	Local vrc As Long
	Local vci As Long
	Local vri As Long
	Local userPainted As Long
	Static hImg As Dword
	Static imgW As Long
	Static imgH As Long
	Dim vc(200): ' Max visible columns
	Dim vr(200): ' Max visible rows

	Function = 0
	p = Table_GetInternalData( hWnd )
	If p = 0 Then Exit Function

	hdc = BeginPaint( hWnd, ps )

	GetCursorPos(cursor)
	MapWindowPoints( %NULL, hWnd, VarPtr(cursor), 1 )

	GetClientRect( hWnd, rc )

	' Ensure bitmap is large enough
	If hImg=0 Or imgW<rc.Right Or imgH<rc.Bottom Then
		If hImg Then DeleteObject( hImg )
		imgW = rc.right
		imgH = rc.bottom
		hImg = CreateCompatibleBitmap( hdc, imgW, imgH )
	End If
	mhdc = CreateCompatibleDC(hdc)
	SaveDc( mhdc )
	SelectObject( mhdc, hImg )
	@p.drewHot = 0
	Call Table_SetBasic( hWnd, mhdc, cursor, p, cellData )

	bbr = CreateSolidBrush( @p.workspaceColor )
	FillRect( cellData.hdc, rc, bbr ): ' Erase the area
	DeleteObject( bbr )

	Table_GetVisCols( p, vc(), vcc, rc, -1 )
	For vci = 0 To vcc-1
		c = vc(vci)
		w = IIf&( c<0, @p.rowHeaderWidth, @p.@Column[c].Width )
		rowWidth += w
		If @p.verticalGrid Then Incr rowWidth
	Next
	rowWidth = Min&( rowWidth, rc.Right )

	r = -1
	cellData.r = -1
	cellData.c = -1
	x = 0
	y = 0
	If @p.ds.getData Then
		If @p.showColHeaders Then
			Call Table_GetVisCols( p, vc(), vcc, rc, -1 )
			' ======================================================
			' Draw the column Headers
			' ======================================================
			For vci = 0 To vcc-1
				c = vc(vci)
				Call Table_SetBasic( hWnd, mhdc, cursor, p, cellData ): ' In case user changed values
				cellData.align = @p.@Column[c].align

				cellData.hFont = @p.hHeadFont
				Call Dword @p.ds.getData Using Table_GetData( -1, c, value )
				cellData.c = c

				w = IIf&( c<0, @p.rowHeaderWidth, @p.@Column[c].Width )
				SetRect( cellData.rc, x, y, x + w, y + @p.rowHeight )
				drawStyle = %TableCellStyle.Normal
				If PtInRect( cellData.rc, cursor ) And @p.hotTrack Then drawStyle = %TableCellStyle.Hot: @p.drewHot = -1

				cellData.headerStyle = @p.colHeaderStyle
				userPainted = 0
				If @p.userPaint Then
					SelectObject( cellData.hdc, cellData.hFont )
					Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.hdrAll, drawStyle, value, cellData ) To userPainted
				End If
				If userPainted=0 Then
					SelectObject( cellData.hdc, cellData.hFont )
					Table_DrawHeader( value, drawStyle, cellData )
				End If

				x += w
				If @p.verticalGrid Then Incr x
				If x>rc.Right Then Exit For
			Next
		End If
	End If

	y = 0
	x = 0
	If @p.ds.getData Then
		cellData.r = -1
		cellData.c = -1
		cellData.hFont = @p.hTextFont
		vcc = 0
		If @p.showRowHeaders Then
			Call Table_GetVisRows( p, vc(), vcc, rc )
			' ======================================================
			' Display row Headers
			' ======================================================
			y = 0
			If @p.showColHeaders Then
				y += @p.rowHeight: ' Ajusting for row Header already displayed
				If @p.horizontalGrid Then Incr y
			End If
			For vci=0 To vcc-1
				r = vc(vci)
				Call Table_SetBasic( hWnd, mhdc, cursor, p, cellData ): ' In case user changed values
				cellData.hFont = @p.hHeadFont
				cellData.r = r

				Call Dword @p.ds.getData Using Table_GetData( r, -1, value )

				w = @p.rowHeaderWidth
				SetRect( cellData.rc, x, y, x + w, y + @p.rowHeight )
				drawStyle = %TableCellStyle.Normal
				If PtInRect( cellData.rc, cursor ) And @p.hotTrack Then
					drawStyle = %TableCellStyle.Hot
					@p.drewHot = -1
				End If

				cellData.headerStyle = @p.rowHeaderStyle
				userPainted = 0
				If @p.userPaint Then
					SelectObject( cellData.hdc, cellData.hFont )
					Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.hdrAll, drawStyle, value, cellData ) To userPainted
				End If
				If userPainted=0 Then
					SelectObject( cellData.hdc, cellData.hFont )
					Table_DrawHeader( value, drawStyle, cellData  )
				End If
				y += @p.rowHeight
				If @p.horizontalGrid Then Incr y
				If y>rc.Bottom Then Exit For
			Next
		End If

		' ======================================================
		' Draw cells
		' ======================================================
		startx = 0
		If @p.showRowHeaders Then
			' Draw Row Headers
			startx += @p.rowHeaderWidth
			If @p.verticalGrid Then Incr startx
		End If

		y = 0
		If @p.showColHeaders Then
			y += @p.rowHeight
			If @p.horizontalGrid Then Incr y
		End If

		Call Table_GetVisCols( p, vc(), vcc, rc, 0 ): ' Get visible columns except row headers
		Call Table_GetVisRows( p, vr(), vrc, rc )

		For vri = 0 To vrc-1
			r = vr(vri)
			cellData.r = r
			x = startx
			' ======================================================
			' Draw column backgrounds for row
			' ======================================================
			For vci = 0 To vcc-1
				c = vc(vci)
				Call Table_SetBasic( hWnd, mhdc, cursor, p, cellData ): ' In case user changed values
				cellData.c = c
				SetRect( cellData.rc, x, y, x + @p.@Column[c].Width, y+@p.rowHeight )
				If @p.@Column[c].backColor Then
					cellData.backColor = @p.@Column[c].backColor
				ElseIf c < @p.frozCols Or r<@p.frozRows Then
					cellData.backColor = @p.frozColor
				Else
					t = 0
					If @p.alternateRows Then t = r Mod 2
					If t Then
						cellData.backColor = @p.altBack
					Else
						cellData.backColor = @p.backColor
					End If
				End If
				userPainted = 0
				If @p.userPaint Then
					SelectObject( cellData.hdc, cellData.hFont )
					Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.cellBack, drawStyle, "", cellData ) To userPainted
				End If
				If userPainted=0 Then
					br = CreateSolidBrush( cellData.backColor )
					FillRect( cellData.hdc, cellData.rc, br )
					DeleteObject( br )
				End If

				x += @p.@Column[c].Width
				If @p.verticalGrid Then Incr x
				If x>rc.Right Then Exit For
			Next

			' ======================================================
			' Overlay row selection/hot
			' ======================================================
			If @p.selectRow Then
				Call Table_SetBasic( hWnd, mhdc, cursor, p, cellData ): ' In case user changed values
				SetRect( cellData.rc, startx, y, rowWidth, y+@p.rowHeight )
				If @p.curRow = r Then
					userPainted = 0
					If @p.userPaint Then
						SelectObject( cellData.hdc, cellData.hFont )
						Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.selBack, drawStyle, "", cellData ) To userPainted
					End If
					If userPainted=0 Then
						DrawSelection( cellData, cellData.rc, 0 )
					End If
				ElseIf cursor.y>=cellData.rc.Top And cursor.y<=cellData.rc.Bottom And cursor.x>=rc.Left And cursor.x<rc.Right And @p.hotTrack Then
					@p.drewHot = -1
					userPainted = 0
					If @p.userPaint Then
						SelectObject( cellData.hdc, cellData.hFont )
						Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.hotBack, drawStyle, "", cellData ) To userPainted
					End If
					If userPainted=0 Then
						DrawSelection( cellData, cellData.rc, -1 )
					End If
				End If
			End If

			SelectClipRgn( cellData.hdc, %NULL )

			' ======================================================
			' Draw cell data
			' ======================================================
			x = startx
			For vci = 0 To vcc-1
				c = vc(vci)
				Call Table_SetBasic( hWnd, mhdc, cursor, p, cellData ): ' In case user changed values
				cellData.c = c
				SetRect( cellData.rc, x, y, x + @p.@Column[c].Width, y+@p.rowHeight )
				drawStyle = %TableCellStyle.Normal
				If PtInRect( cellData.rc, cursor ) And @p.hotTrack Then drawStyle = %TableCellStyle.Hot
				If @p.selectRow And cursor.y>=cellData.rc.Top And cursor.y<=cellData.rc.Bottom And cursor.x>=rc.Left And cursor.x<=rc.Right And @p.hotTrack Then drawStyle = %TableCellStyle.Hot
				If (@p.curCol = c And @p.curRow = r) Or (@p.curRow = r And @p.selectRow) Then drawStyle = %TableCellStyle.Selected
				If drawStyle = %TableCellStyle.Hot Then @p.drewHot = -1
				Call Dword @p.ds.getData Using Table_GetData( r, c, value )

				If @p.@Column[c].foreColor Then
					cellData.foreColor = @p.@Column[c].foreColor
				Else
					cellData.foreColor = @p.foreColor
				End If
				cellData.c = c

				cellData.drawStyle = drawStyle
				cellData.align = @p.@Column[c].align

				' ======================================================
				' Draw single cell overlay
				' ======================================================
				If IsFalse @p.selectRow Then
					If drawStyle = %TableCellStyle.Selected Then
						userPainted = 0
						If @p.userPaint Then
							SelectObject( cellData.hdc, cellData.hFont )
							Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.selBack, drawStyle, "", cellData ) To userPainted
						End If
						If userPainted=0 Then
							DrawSelection( cellData, cellData.rc, 0 )
						End If
					ElseIf drawStyle = %TableCellStyle.Hot Then
						@p.drewHot = -1
						userPainted = 0
						If @p.userPaint Then
							SelectObject( cellData.hdc, cellData.hFont )
							Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.hotBack, drawStyle, "", cellData ) To userPainted
						End If
						If userPainted=0 Then
							DrawSelection( cellData, cellData.rc, -1 )
						End If
					End If
				Else
					' emphasize current cell for hot/selected when selecting row
					If drawStyle = %TableCellStyle.Selected And (@p.curCol = c And @p.curRow = r) Then
						AdjustColor( cellData.selColor1, 1 ): AdjustColor( cellData.selColor2, 1 ): AdjustColor( cellData.selBColor, 1 ): ' "Darken"
						userPainted = 0
						If @p.userPaint Then
							SelectObject( cellData.hdc, cellData.hFont )
							Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.selBack, drawStyle, "", cellData ) To userPainted
						End If
						If userPainted=0 Then
							DrawSelection( cellData, cellData.rc, 0 )
						End If
						AdjustColor( cellData.selColor1, -1 ):  AdjustColor( cellData.selColor2, -1 ):  AdjustColor( cellData.selBColor, -1 ): ' Lighten
					ElseIf drawStyle = %TableCellStyle.Hot And PtInRect( cellData.rc, cursor ) Then
						@p.drewHot = -1
						AdjustColor( cellData.hotColor1, 1 ): AdjustColor( cellData.hotColor2, 1 ): AdjustColor( cellData.hotBColor, 1 ): ' Darken
						userPainted = 0
						If @p.userPaint Then
							SelectObject( cellData.hdc, cellData.hFont )
							Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.hotBack, drawStyle, "", cellData ) To userPainted
						End If
						If userPainted=0 Then
							DrawSelection( cellData, cellData.rc, -1 )
						End If
						AdjustColor( cellData.hotColor1, -1 ):  AdjustColor( cellData.hotColor2, -1 ):  AdjustColor( cellData.hotBColor, -1 ): ' Lighten
					End If
				End If
				SelectClipRgn( cellData.hdc, %NULL )

				userPainted = 0
				If @p.userPaint Then
					SelectObject( cellData.hdc, cellData.hFont )
					Call Dword @p.userPaint Using Table_PaintSample( %PaintPart.cellFore, drawStyle, value, cellData ) To userPainted
				End If
				If userPainted=0 Then
					cellData.value = StrPtr( value )
					Call Table_DrawCell( cellData )
				End If

				x += @p.@Column[c].Width
				If @p.verticalGrid Then Incr x
				If x>rc.Right Then Exit For
			Next

			y += @p.rowHeight
			If @p.horizontalGrid Then Incr y
			If y>rc.Bottom Then Exit For
		Next

	End If

	GetClientRect( hWnd, rc )

	gpn = CreatePen( %PS_SOLID, 1, @p.gridColor )
	opn = SelectObject( cellData.hdc, gpn )

	If @p.verticalGrid Then
		' Vertical table
		' Add 1 to row height for each table line, add 1 to rows for headers
		bt = Min&( (@p.rowHeight + IIf&( @p.horizontalGrid, 1, 0) ) * ( @p.rows - @p.topRow + 1 ), rc.Bottom )
		y = 0
		x = 0
		If @p.showRowHeaders Then
			x += @p.rowHeaderWidth
			MoveToEx( cellData.hdc, x, 0, ByVal %NULL )
			LineTo( cellData.hdc, x, bt )
			Incr x
		End If
		If x<rc.Right Then
			For vci = 0 To vcc-1
				c = vc(vci)
				x += @p.@Column[c].Width
				MoveToEx( cellData.hdc, x, 0, ByVal %NULL )
				LineTo( cellData.hdc, x, bt )
				Incr x
				If x > rc.Right Then Exit For
			Next
		End If
	End If

	If @p.horizontalGrid Then
		' Horizontal table
		y = 0
		x = 0
		If @p.showColHeaders Then
			y += @p.rowHeight
			MoveToEx( cellData.hdc, 0,  y, ByVal %NULL )
			LineTo( cellData.hdc, rowWidth, y )
			Incr y
		End If

		If y < rc.Bottom Then
			For vri = 0 To vrc-1
				r = vr(vri)
				y += @p.rowHeight
				MoveToEx( cellData.hdc, 0,  y, ByVal %NULL )
				LineTo( cellData.hdc, rowWidth, y )
				Incr y
				If y > rc.Bottom Then Exit For
			Next
		End If
	End If
	SelectObject( cellData.hdc, opn )
	DeleteObject( gpn )

	GetClientRect( hWnd, rc )
	Call BitBlt( hdc, 0,0,rc.right,rc.bottom, mhdc, 0, 0, %SRCCOPY )
	RestoreDc( mhdc, -1 )
	DeleteDc( mhdc )

	EndPaint( hwnd, ps )
	If @p.drewHot Then
		SetTimer( hwnd, %Table_PaintTimer, 100, 0 )
	Else
		KillTimer( hWnd, %Table_PaintTimer )
	End If
End Function

Sub Table_GetVisCols( ByVal p As TableData Ptr, ByRef vs() As Long, ByRef vsc As Long, ByRef rc As RECT, ByVal includeHeader As Long )
	Local x As Long
	Local c As Long

	vsc = 0
	If @p.showRowHeaders Then
		' Draw Row Headers
		If includeHeader Then
			vs(vsc) = -1
			Incr vsc
		End If
		x += @p.rowHeaderWidth
		If @p.verticalGrid Then Incr x
	End If

	If x<rc.Right Then
		' Draw froz column Headers
		For c = 0 To @p.frozCols -1
			vs(vsc) = c
			Incr vsc

			x += @p.@Column[c].Width
			If @p.verticalGrid Then Incr x
			If x>rc.Right Then Exit For
		Next
	End If

	If x<rc.Right Then
		' Draw other cells
		For c = @p.leftCol To @p.cols-1
			vs(vsc) = c
			Incr vsc

			x += @p.@Column[c].Width
			If @p.verticalGrid Then Incr x
			If x>rc.Right Then Exit For
		Next
	End If
End Sub

Sub Table_GetVisRows( ByVal p As TableData Ptr, ByRef vs() As Long, ByRef vsc As Long, ByRef rc As RECT )
	Local y As Long
	Local r As Long
	vsc = 0
	If @p.showColHeaders Then
		' Already displayed so don't add to list
		y += @p.rowHeight
		If @p.horizontalGrid Then Incr y
	End If
	For r = 0 To @p.frozRows - 1
		vs(vsc) = r
		Incr vsc
		y += @p.rowHeight
		If @p.horizontalGrid Then Incr y
		If y>rc.Bottom Then Exit For
	Next
	For r = @p.topRow To @p.rows-1
		vs(vsc) = r
		Incr vsc
		y += @p.rowHeight
		If @p.horizontalGrid Then Incr y
		If y>rc.Bottom Then Exit For
	Next
End Sub

Sub Table_DrawCell( ByRef cellData As DrawCellData )
	Local br As Dword
	Local foreColor As Dword
	Local backColor As Dword
	Local c As CCOver
	Local dir As Long
	Local st As Dword

	foreColor = cellData.foreColor
	backColor = cellData.backColor

	InflateRect( cellData.rc, -4, -2 )
	Select Case cellData.drawStyle
		Case %TableCellStyle.Normal:    foreColor = cellData.foreColor
		Case %TableCellStyle.Hot:       foreColor = cellData.hotTColor
		Case %TableCellStyle.Selected:  foreColor = cellData.selTColor
		Case %TableCellStyle.Inactive:  foreColor = RGB(128,128,128)
	End Select
	SelectObject( cellData.hdc, cellData.hFont )
	SetTextColor( cellData.hdc, foreColor )
	SetBkMode( cellData.hdc, %TRANSPARENT )
	DrawText( cellData.hdc, cellData.@value, Len(cellData.@value), cellData.rc, cellData.align )
	InflateRect( cellData.rc, 4, 2 )
End Sub

Sub Table_DrawHeader( ByRef title As WString, ByVal drawStyle As Dword, cellData As DrawCellData ): 'ByVal hdc As Dword, ByRef rc As RECT, ByVal drawStyle As Long, ByVal align As Dword )
	Local ops As DTTOPTS
	Local st As Dword
	Local rc2 As RECT

	If cellData.headerStyle = %HeaderStyle.Themed And Table_hTheme Then
		Select Case drawStyle
			Case %TableCellStyle.Normal:   st = %HIS_NORMAL
			Case %TableCellStyle.Hot:      st = %HIS_HOT
			Case %TableCellStyle.Selected, %TableCellStyle.Pushed:   st = %HIS_PRESSED
			Case %TableCellStyle.Inactive: st = %HIS_NORMAL
		End Select
		CopyRect( rc2, cellData.rc )
		DrawThemeEdge( Table_hTheme, cellData.hdc, %HP_HEADERITEM, st, rc2, %BDR_RAISEDOUTER, %BF_ADJUST Or %BF_RECT, ByVal %NULL )
		DrawThemeBackground( Table_hTheme, cellData.hdc, %HP_HEADERITEM, st, rc2, ByVal %NULL )
		If Len(title)>0 Then
			InflateRect( rc2, -2, -2 )
			SetBkMode( cellData.hdc, %TRANSPARENT )
			Local wtitle As WString
			wtitle = title
			If drawStyle = %TableCellStyle.Inactive Then
				SetTextColor( cellData.hdc, RGB(128,128,128) )
				DrawText( cellData.hdc, ByVal StrPtr(title), Len(title), rc2, cellData.align )
			Else
				DrawThemeText( Table_hTheme, cellData.hdc, %HP_HEADERITEM, st, ByVal StrPtr(wtitle), Len(wtitle), cellData.align, 0, rc2 )
			End If
		End If
		Exit Sub
	ElseIf cellData.headerStyle = %HeaderStyle.Button Or (cellData.headerStyle = %HeaderStyle.Themed And IsFalse Table_hTheme ) Then
		Select Case drawStyle
			Case %TableCellStyle.Normal:   st = %DFCS_BUTTONPUSH
			Case %TableCellStyle.Hot:      st = %DFCS_BUTTONPUSH Or %DFCS_HOT
			Case %TableCellStyle.Selected, %TableCellStyle.Pushed:   st = %DFCS_BUTTONPUSH Or %DFCS_PUSHED
			Case %TableCellStyle.Inactive: st = %DFCS_BUTTONPUSH Or %DFCS_INACTIVE
		End Select
		DrawFrameControl( cellData.hdc, cellData.rc, %DFC_BUTTON, st )
		' Continuing to draw text
	ElseIf cellData.headerStyle = %HeaderSTyle.Flat Then
		Local clr As Dword
		Local br As Dword
		Select Case drawStyle
			Case %TableCellStyle.Normal:   clr = cellData.backColor
			Case %TableCellStyle.Hot:      clr = cellData.hotColor1
			Case %TableCellStyle.Selected, clr = cellData.selColor1
			Case %TableCellStyle.Inactive: clr = RGB(128,128,128)
		End Select
		br = CreateSolidBrush( clr )
		FillRect( cellData.hdc, cellData.rc, br )
		DeleteObject( br )
		' Continuing to draw text
	End If

	If Len(title)>0 Then
		InflateRect( cellData.rc, -2, -2 )
		SetBkMode( cellData.hdc, %TRANSPARENT )
		If drawStyle = %TableCellStyle.Inactive Then
			SetTextColor( cellData.hdc, RGB(128,128,128) )
			DrawText( cellData.hdc, ByVal StrPtr(title), Len(title), cellData.rc, cellData.align )
		Else
			SetTextColor( cellData.hdc, cellData.foreColor )
			DrawText( cellData.hdc, ByVal StrPtr(title), Len(title), cellData.rc, cellData.align )
		End If
		InflateRect( cellData.rc, 2, 2 )
	End If
End Sub

Sub Table_OnThemeChanged( ByVal hWnd As Dword )
	If Table_hTheme Then
		CloseThemeData( Table_hTheme )
	End If
	Table_hTheme = OpenThemeData( hWnd, "HEADER" )
End Sub

Sub Table_OnCreate( ByVal hWnd As Dword )
	Local p As TableData Ptr
	Local i As Long

	If IsFalse Table_hTheme Then
		Table_hTheme = OpenThemeData( hWnd, "HEADER" )
	End If

	p = GlobalAlloc(%GPTR, SizeOf( TableData ) )
	Call Table_SetInternalData( hWnd, p )

	@p.rows = 1
	@p.cols = 0
	@p.cols = 0
	@p.sizeCol = -2
	@p.sizePos = 0
	@p.allowResize = -1
	Call Table_SetColumns( hWnd, 1 )
	@p.topRow = 0
	@p.leftCol = 0
	@p.curCol = 0
	@p.curRow = 0
	@p.hotTrack = 0
	@p.horizontalGrid = 0
	@p.verticalGrid = 0
	@p.rowHeight = 20
	@p.selectKey = %VK_SPACE

	@p.hSize = LoadCursor(%NULL, ByVal %IDC_SIZEWE )
	@p.hNorm = LoadCursor(%NULL, ByVal %IDC_ARROW )

	@p.frozRows = 0
	@p.frozCols = 0
	@p.colHeaderStyle = 1
	@p.rowHeaderStyle = 1
	@p.showColHeaders = 1
	@p.showRowHeaders = 1
	@p.rowHeaderWidth = 50
	@p.userPaint = 0

	@p.hHeadFont = CreateFont(16,0,0,0, %FW_NORMAL, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, "Arial" )
	@p.hTextFont = CreateFont(16,0,0,0, %FW_NORMAL, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, "Arial" )

	@p.gridColor = GetSysColor( %COLOR_ACTIVEBORDER )
	@p.frozColor = GetSysColor( %COLOR_INFOBK )
	@p.workspaceColor = GetSysColor( %COLOR_APPWORKSPACE )
	@p.foreColor = GetSysColor( %COLOR_WINDOWTEXT )
	@p.backColor = GetSysColor( %COLOR_WINDOW )
	@p.altBack = GetSysColor( %COLOR_INFOBK )
	@p.alternateRows = 0

	@p.selColor1 = GetSysColor( %COLOR_GRADIENTACTIVECAPTION )
	@p.selColor2 = GetSysColor( %COLOR_ACTIVECAPTION )
	@p.selBColor = GetSysColor( %COLOR_ACTIVECAPTION )
	@p.selTColor = GetSysColor( %COLOR_CAPTIONTEXT )

	@p.hotColor1 = GetSysColor( %COLOR_GRADIENTINACTIVECAPTION ): ' Light gradient
	@p.hotColor2 = GetSysColor( %COLOR_INACTIVECAPTION ): ' Dark gradient
	@p.hotBColor = GetSysColor( %COLOR_GRADIENTACTIVECAPTION ): ' Border Color
	@p.hotTColor = GetSysColor( %COLOR_INACTIVECAPTIONTEXT ): ' Text color

	@p.sysGridColor = -1
	@p.sysForeColor = -1
	@p.sysBackColor = -1
	@p.sysFrozColor = -1
	@p.sysWorkspaceColor = -1
	@p.sysSelColor1 = -1
	@p.sysSelColor2 = -1
	@p.sysSelBColor = -1
	@p.sysSelTColor = -1
	@p.sysHotColor1 = -1
	@p.sysHotColor2 = -1
	@p.sysHotBColor = -1
	@p.sysHotTColor = -1
	@p.sysAltBack = -1

	@p.selectRow = -1
	@p.colHeaderStyle = IIf&( Table_HasManifest, %HeaderStyle.Themed, %HeaderStyle.Button )
	@p.rowHeaderStyle = IIf&( Table_HasManifest, %HeaderStyle.Themed, %HeaderStyle.Button )

	Incr tableCount
	InvalidateRect( hWnd, ByVal %NULL, 1 )
End Sub

Sub Table_OnDestroy( ByVal hWnd As Dword )
	Local p As TableData Ptr

	If Table_hTheme Then CloseThemeData( Table_hTheme )

	p = Table_GetInternalData( hWnd )
	If @p.cols Then GlobalFree( @p.cols )
	If p Then GlobalFree( p )
	Table_SetInternalData( hWnd, 0 )
	Decr tableCount
	If tableCount = 0 Then
		UnregisterClass( $TABLE_CLASS, GetModuleHandle( ByVal 0 ) )
	End If
End Sub

Sub Table_Init()
	Local wc As WNDCLASSEX
	Local i As Long
	Local className As WStringZ*20

	className = $TABLE_CLASS

	If GetClassInfoEx(%NULL, $TABLE_CLASS, wc) Then Exit Sub: ' Already registered

	Table_HasManifest = IIf&(FindResource( GetModuleHandle( ByVal 0 ), ByVal MakeIntResource(1), ByVal %RT_MANIFEST)<>0, -1, 0)

	' Register class for lcTable window
	wc.cbsize = SizeOf(wc)
	wc.style = %CS_GLOBALCLASS Or %CS_DBLCLKS
	wc.lpfnWndProc = CodePtr( Table_ControlProc )
	wc.cbClsExtra = 0
	wc.cbWndExtra = SizeOf(i): ' Pointer to TableData
	wc.hInstance = GetModuleHandle( ByVal 0 )
	wc.hIcon = %NULL
	wc.hCursor = LoadCursor(%NULL, ByVal %IDC_ARROW)
	wc.hbrBackground = CreateSolidBrush(RGB(255,255,255))
	wc.lpszMenuName =  0
	wc.lpszClassName = VarPtr(className)
	wc.hIconSm = 0
	Call RegisterClassEx( wc )
End Sub

Function Table_GetInternalData( ByVal hWnd As Dword) As Long
	Function = GetWindowLong(hWnd, 0)
End Function

Sub Table_SetInternalData( ByVal hWnd As Dword, ByVal value As Long)
	Call SetWindowLong(hWnd, 0, value)
End Sub

Sub Table_SetColumns( ByVal hWnd As Dword, ByVal cols As Long )
	Local p As TableData Ptr
	Local w As TableColumnData Ptr
	Local i As Long

	If cols < 1 Then Exit Sub: ' Invalid

	p = Table_GetInternalData( hWnd )
	If p = 0 Then Exit Sub

	If cols <= @p.cols Then
		' Already room
		@p.cols = cols
		Exit Sub
	End If

	w = GlobalAlloc( %GPTR, SizeOf(TableColumnData) * cols )
	For i = 0 To @p.cols-1
		@w[i].Width = @p.@Column[i].Width
		@w[i].align = @p.@Column[i].align
		@w[i].foreColor = @p.@Column[i].foreColor
		@w[i].backColor = @p.@Column[i].backColor
	Next
	For i = @p.cols To cols-1
		@w[i].Width = 100
		@w[i].align = %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS
		@w[i].foreColor = 0
		@w[i].backColor = 0
	Next

	If @p.column Then GlobalFree( @p.column )
	@p.column = w
	@p.cols = cols
End Sub

Sub GetShifts( ByRef sk As ShiftKeys )
	sk.isShift = IIf&( (GetKeyState(%VK_Shift)   And &h80) <> 0, -1, 0)
	sk.isCtrl  = IIf&( (GetKeyState(%VK_CONTROL) And &h80) <> 0, -1, 0)
	sk.isAlt   = IIf&( (GetKeyState(%VK_Menu)    And &h80) <> 0, -1, 0)
	sk.isWnd   = IIf&( (GetKeyState(%VK_Apps)    And &h80) <> 0, -1, 0)
End Sub

Sub DrawSelection( dta As DrawCellData, ByRef rc As RECT, ByVal hot As Long )
	Dim hClipRgn As Dword
	Dim pRgn As Dword
	Dim vert(1) As TRIVERTEX
	Dim gRect As GRADIENT_RECT
	Dim pn As Dword
	Dim opn As Dword
	Dim obr As Dword
	Dim obk As Dword
	Dim b1 As Dword
	Dim b2 As Dword
	Dim c1 As Dword
	Dim c2 As Dword
	Dim c3 As Dword
	Dim cc As CCOver

	InflateRect( rc, -1, -1 )
	If Hot Then
		b1 = dta.hotBColor
		c1 = dta.hotColor1
		c2 = dta.hotColor2
	Else
		b1 = dta.selBColor
		c1 = dta.selColor1
		c2 = dta.selColor2
	End If

	hClipRgn = CreateRoundRectRgn(rc.Left, rc.Top, rc.Right+1, rc.Bottom+1, 5, 5 )
	pRgn = SelectClipRgn( dta.hdc, hClipRgn )

	cc.v = c1
	vert(0).x     = rc.Left
	vert(0).y     = rc.Top
	vert(0).Red   = Mak(Word, 0, cc.p.r )
	vert(0).Green = Mak(Word, 0, cc.p.g )
	vert(0).Blue  = Mak(Word, 0, cc.p.b )
	vert(0).Alpha = &hff00

	cc.v = c2
	vert(1).x     = rc.Right
	vert(1).y     = rc.Bottom
	vert(1).Red   = Mak(Word, 0, cc.p.r )
	vert(1).Green = Mak(Word, 0, cc.p.g )
	vert(1).Blue  = Mak(Word, 0, cc.p.b )
	vert(1).Alpha = &hff00

	gRect.UpperLeft  = 0
	gRect.LowerRight = 1

	GradientFill( dta.hdc, vert(0), 2, gRect, 1, %GRADIENT_FILL_RECT_V)

	SelectClipRgn( dta.hdc, %NULL )

	pn = CreatePen( %PS_SOLID, 1, b1 )
	opn = SelectObject( dta.hdc, pn )
	obr = SelectObject( dta.hdc, GetStockObject( %NULL_BRUSH ) )
	RoundRect( dta.hdc, rc.Left, rc.Top, rc.Right, rc.Bottom, 5, 5 )
	SelectObject( dta.hdc, obr )
	SelectObject( dta.hdc, opn )

	DeleteObject( hClipRgn )
	DeleteObject( pn )
	InflateRect( rc, 1, 1 )
End Sub

Sub AdjustColor( ByRef clr As Dword, ByVal dir As Long )
	Local c As CCOver
	Local amt As Long

	c.v = clr
	If (c.p.R*.299 + c.p.G*.587 + c.p.B*.114)<128 Then amt=40 Else amt=-40
	c.p.r = Max&(Min&( c.p.r + (dir * amt), 255), 0)
	c.p.g = Max&(Min&( c.p.g + (dir * amt), 255), 0)
	c.p.b = Max&(Min&( c.p.b + (dir * amt), 255), 0)
	clr = c.v
End Sub

Sub DrawGradientBar( ByVal hdc As Dword, ByRef rc As RECT, ByVal c1 As Dword, ByVal c2 As Dword, ByVal vert As Long )
	Dim vert(1) As TRIVERTEX
	Dim gRect As GRADIENT_RECT
	Dim cc As CCOver
	cc.v = c1
	vert(0).x     = rc.Left
	vert(0).y     = rc.Top
	vert(0).Red   = Mak(Word, 0, cc.p.r )
	vert(0).Green = Mak(Word, 0, cc.p.g )
	vert(0).Blue  = Mak(Word, 0, cc.p.b )
	vert(0).Alpha = &hff00
	cc.v = c2
	vert(1).x     = rc.Right
	vert(1).y     = rc.Bottom
	vert(1).Red   = Mak(Word, 0, cc.p.r )
	vert(1).Green = Mak(Word, 0, cc.p.g )
	vert(1).Blue  = Mak(Word, 0, cc.p.b )
	vert(1).Alpha = &hff00
	gRect.UpperLeft  = 0
	gRect.LowerRight = 1
	GradientFill( hdc, vert(0), 2, gRect, 1, IIf&(vert, %GRADIENT_FILL_RECT_V, %GRADIENT_FILL_RECT_H) )
End Sub
