#Compile Exe "TableDemo.exe"
#Compiler PBWin 10
#Dim All

%UNICODE = 1
%INCLUDE=1
#Include Once "Win32Api.inc"
#Include Once "TableInfo.inc"
#Include Once "Table.inc"

#Resource Manifest,     1, "main.xml"

$WIN_CLASS = "lcDemoWin"
%CTL_LISTBOX = 100
%CTL_TABLE   = 101

%LIST_WIDTH = 200

Global ghWnd As Dword
Global hTable As Dword
Global tLines() As String

Function PBMain () As Long
	Local hWnd As Dword
	Local hChild As Dword
	Local rc As RECT
	Local ds As DataSource
	Local i As Long
	Local st As Dword
	ReDim tLines(1)

	Call Initialize()

	hWnd = CreateWindowEx( 0, $WIN_CLASS, "Demo Table View", %WS_OverlappedWindow Or %WS_Visible, %CW_USEDEFAULT, %CW_USEDEFAULT, 640, 480, %NULL, 0, GetModuleHandle(ByVal 0), ByVal 0 )
	ghWnd = hWnd

	GetClientRect(hWnd, rc)
	hChild = CreateWindowEx( 0, "LISTBOX", "", %WS_Child Or %WS_Visible Or %WS_Border Or %LBS_Notify Or %LBS_HasStrings Or %LBS_OwnerDrawFixed Or %WS_VScroll Or %LBS_NoIntegralHeight Or %LBS_DisableNoScroll, _
													0, 0, %LIST_WIDTH, 480, hWnd, %CTL_LISTBOX, GetModuleHandle(ByVal 0), ByVal 0 )
	Call AddString( hChild, "-Selector coloring",  0 )
	Call AddString( hChild, "Explorer", CodePtr( SetExplorerSelectionColors ) )
	Call AddString( hChild, "User",     CodePtr( SetUserSelectionColors ) )
	Call AddString( hChild, "Default",  CodePtr( SetDefaultSelectionColors ) )

	Call AddString( hChild, "-Selection type",  0 )
	Call AddString( hChild, "Row",  CodePtr( SelectRow ) )
	Call AddString( hChild, "Cell",  CodePtr( SelectCell ) )

	Call AddString( hChild, "-Hot track",  0 )
	Call AddString( hChild, "On",  CodePtr( HotTrack ) )
	Call AddString( hChild, "Off",  CodePtr( NoHotTrack ) )

	Call AddString( hChild, "-Resize",  0 )
	Call AddString( hChild, "On",  CodePtr( AllowResize ) )
	Call AddString( hChild, "Off",  CodePtr( NoResize ) )

	Call AddString( hChild, "-Alternate",  0 )
	Call AddString( hChild, "Green",  CodePtr( GreenAlternate ) )
	Call AddString( hChild, "Blue",  CodePtr( BlueAlternate ) )
	Call AddString( hChild, "None",  CodePtr( NoAlternate ) )

	Call AddString( hChild, "-Freeze",  0 )
	Call AddString( hChild, "1 row 2 cols",  CodePtr( Freeze2Rows1Col ) )
	Call AddString( hChild, "2 rows 1 col",  CodePtr( Freeze2Cols1Row ) )
	Call AddString( hChild, "Clear",  CodePtr( FreezeNone ) )

	Call AddString( hChild, "-Paint",  0 )
	Call AddString( hChild, "User",  CodePtr( UserPaint ) )
	Call AddString( hChild, "Internal",  CodePtr( InternalPaint ) )

	Call AddString( hChild, "-Headers",  0 )
	Call AddString( hChild, "Row",  CodePtr( RowHeaders ) )
	Call AddString( hChild, "Col",  CodePtr( ColHeaders ) )
	Call AddString( hChild, "Both",  CodePtr( BothHeaders ) )
	Call AddString( hChild, "None",  CodePtr( NoHeaders ) )

	Call AddString( hChild, "-Header styles",  0 )
	Call AddString( hChild, "Themed",  CodePtr( ThemedHeaders ) )
	Call AddString( hChild, "Button",  CodePtr( ButtonHeaders ) )
	Call AddString( hChild, "Flat",  CodePtr( FlatHeaders ) )
	Call AddString( hChild, "Mixed",  CodePtr( ThemedButtonHeaders ) )

	Call AddString( hChild, "- Gridlines",  0 )
	Call AddString( hChild, "Both",  CodePtr( BothGrid ) )
	Call AddString( hChild, "Horizontal",  CodePtr( HorizontalGrid ) )
	Call AddString( hChild, "Vertical",  CodePtr( VerticalGrid ) )
	Call AddString( hChild, "None",  CodePtr( NoGrid ) )

	Call AddString( hChild, "- Row height",  0 )
	Call AddString( hChild, "23",  CodePtr( RowHeight23 ) )
	Call AddString( hChild, "40",  CodePtr( RowHeight40 ) )
	Call AddString( hChild, "20",  CodePtr( RowHeight20 ) )

	Call AddString( hChild, "- Text color",  0 )
	Call AddString( hChild, "Red",  CodePtr( RedText ) )
	Call AddString( hChild, "Dark blue",  CodePtr( DarkBlueText ) )
	Call AddString( hChild, "Black",  CodePtr( BlackText ) )

	Call AddString( hChild, "- Background color",  0 )
	Call AddString( hChild, "Button",  CodePtr( ButtonBack ) )
	Call AddString( hChild, "Pale yellow",  CodePtr( PaleYellowBack ) )
	Call AddString( hChild, "Pale blue",  CodePtr( PaleBlueBack ) )
	Call AddString( hChild, "Default",  CodePtr( DefaultBack ) )

	Call AddString( hChild, "- Text alignment",  0 )
	Call AddString( hChild, "Messed-up",  CodePtr( MessedUpAlign ) )
	Call AddString( hChild, "Left",  CodePtr( LeftAlign ) )
	Call AddString( hChild, "Right",  CodePtr( RightAlign ) )
	Call AddString( hChild, "Center",  CodePtr( CenterAlign ) )

	Call AddString( hChild, "- Data source",  0 )
	Call AddString( hChild, "Sample",  CodePtr( SampleData ) )
	Call AddString( hChild, "Employee",  CodePtr( EmployeeData ) )
	Call AddString( hChild, "Sales",  CodePtr( SalesData ) )
	SendMessage( hChild, %LB_SETCURSEL, 0, -1 )

	hTable = NewTable(hWnd, %LIST_WIDTH, 0, rc.Right-%LIST_WIDTH, rc.Bottom, %CTL_TABLE )
	Call SampleData()

'  Table_SetPos( hTable, 5, 2 ): ' Start on 6th row, 3rd column
'  Table_SetWorkspaceColor( hTable, RGB(28,49,75) ): ' Defaults to COLOR_APPWORKSPACE

	ShowWindow( hWnd, %SW_Show )
	UpdateWindow( hWnd )
	Window_OnSize( hWnd )

	SetFocus( hChild )

	Call Run()
End Function

Sub SampleData()
	Local i As Long
	Call Table_SetDataSource2( hTable, CodePtr( Test_GetData ), CodePtr( Test_SetData ), 2000, 676 )
	For i=0 To 675
		Table_SetCol( hTable, i, 100, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, 0, 0 ): ' wnd, col, style, fg, bg
	Next
End Sub

Sub LoadData( filename As WString )
	ReDim tLines(1000)
	Dim cnt As Long
	Open filename For Input As #1
	While Not Eof(1)
		Line Input #1, tlines(cnt)
		If Trim$(tlines(cnt))<>"" Then
			Incr cnt
		End If
	Wend
	ReDim Preserve tlines(cnt-1)
	Close #1
End Sub

Sub AllowResize()
	Call Table_SetAllowResize( hTable, -1 )
End Sub

Sub NoResize()
	Call Table_SetAllowResize( hTable, 0 )
End Sub

Sub EmployeeData()
	Call LoadData("emp.tsv")

	Call Table_SetDataSource2( hTable, CodePtr( Test_GetArray ), 0, UBound( tlines() ), ParseCount( tlines(0), $Tab) )
End Sub

Sub SalesData()
	Call LoadData("sales.tsv")

	Call Table_SetDataSource2( hTable, CodePtr( Test_GetArray ), 0, UBound( tlines() ), ParseCount( tlines(0), $Tab) )

	Local i As Long
	For i=7 To 9
		Table_SetCol( hTable, i, 100, %DT_RIGHT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, 0, 0 ): ' wnd, col, style, fg, bg
	Next
End Sub

Sub MessedupAlign()
	Local i As Long
	Local st As Dword
	Table_SetCol( hTable, 0, 120, %DT_Right Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, RGB(255,0,0), 0 )
	Table_SetCol( hTable, 2, 120, %DT_CENTER Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, RGB(220,255,220), RGB(0,80,0) )
	For i = 3 To 1999
		Select Case i Mod 3
			Case 0: st = %DT_LEFT
			Case 1: st = %DT_Center
			Case 2: st = %DT_Right
		End Select
		Table_SetCol( hTable, i, 100, st Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, 0, 0 ): ' wnd, col, style, fg, bg
	Next
End Sub
Sub LeftAlign()
	Local i As Long
	For i = 0 To 1999
		Table_SetCol( hTable, i, 100, %DT_Left Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, 0, 0 ): ' wnd, col, style, fg, bg
	Next
End Sub
Sub RightAlign()
	Local i As Long
	For i = 0 To 1999
		Table_SetCol( hTable, i, 100, %DT_RIGHT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, 0, 0 ): ' wnd, col, style, fg, bg
	Next
End Sub
Sub CenterAlign()
	Local i As Long
	For i = 0 To 1999
		Table_SetCol( hTable, i, 100, %DT_CENTER Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS, 0, 0 ): ' wnd, col, style, fg, bg
	Next
End Sub


Sub GreenAlternate()
	Table_SetAlternatingRows( hTable, 1, RGB(216,238,185) ): 'Yes/No, alternating back color
End Sub
Sub BlueAlternate()
	Table_SetAlternatingRows( hTable, 1, RGB(220,230,241) ): 'Yes/No, alternating back color
End Sub
Sub NoAlternate()
	Table_SetAlternatingRows( hTable, 0, 0 ): 'Yes/No, alternating back color
End Sub

Sub ButtonBack()
	Table_SetBackColor( hTable, GetSysColor( %COLOR_BTNFACE ) ): ' Defaults to COLOR_WINDOW
End Sub
Sub PaleYellowBack()
	Table_SetBackColor( hTable, RGB(255,255,233) ): ' Defaults to COLOR_WINDOW
End Sub
Sub PaleBlueBack()
	Table_SetBackColor( hTable, RGB(200,222,236) ): ' Defaults to COLOR_WINDOW
End Sub
Sub DefaultBack()
	Table_SetBackColor( hTable, GetSysColor( %COLOR_WINDOW ) ): ' Defaults to COLOR_WINDOW
End Sub

Sub RedText()
	Table_SetForeColor( hTable, RGB(255,80,80) ): ' Defaults to COLOR_WINDOWTEXT
End Sub
Sub DarkBlueText()
	Table_SetForeColor( hTable, RGB(54,95,145) ): ' Defaults to COLOR_WINDOWTEXT
End Sub
Sub BlackText()
	Table_SetForeColor( hTable, RGB(1,1,1) ): ' Defaults to COLOR_WINDOWTEXT
End Sub


Sub RowHeight23
	Table_SetRowHeight( hTable, 23 ): ' Defaults to 20
End Sub
Sub RowHeight40
	Table_SetRowHeight( hTable, 40 ): ' Defaults to 20
End Sub
Sub RowHeight20
	Table_SetRowHeight( hTable, 20 ): ' Defaults to 20
End Sub
Sub BothGrid()
	Table_SetTablelines( hTable, 1, 1, RGB(220,220,220) ):  ' Horizontal, Vertical, Color
End Sub
Sub HorizontalGrid()
	Table_SetTablelines( hTable, 1, 0, RGB(220,128,128) ):  ' Horizontal, Vertical, Color
End Sub
Sub VerticalGrid()
	Table_SetTablelines( hTable, 0, 1, RGB(220,220,255) ):  ' Horizontal, Vertical, Color
End Sub
Sub NoGrid()
	Table_SetTablelines( hTable, 0, 0, RGB(220,220,220) ):  ' Horizontal, Vertical, Color
End Sub

Sub SetExplorerSelectionColors()
	Table_SetSelectColors( hTable, RGB( &hEB,&hF4,&hFD), RGB( &hC1,&hDB,&hFC ), RGB( &h76, &h9E, &hCE ), RGB(0,0,0) )
	Table_SetHotColors( hTable, RGB(255,255,255), RGB( &hEB, &hF4, &hFD ), RGB( &hB8, &hD6, &hFB ), RGB(0,0,128) )
End Sub
Sub SetUserSelectionColors()
	Table_SetSelectColors( hTable, RGB(240,244,249), RGB(201,216,233), RGB(36,65,96), RGB(56,95,137) )
	Table_SetHotColors( hTable, RGB(255,255,233), RGB(255,255,159), RGB(108,108,0), RGB(255,0,0) )
End Sub
Sub SetDefaultSelectionColors()
	Table_SetSelectColors( hTable, GetSysColor( %COLOR_GRADIENTACTIVECAPTION ), GetSysColor( %COLOR_ACTIVECAPTION ), GetSysColor( %COLOR_ACTIVECAPTION ), GetSysColor( %COLOR_CAPTIONTEXT ) )
	Table_SetHotColors( hTable, GetSysColor( %COLOR_GRADIENTINACTIVECAPTION ), GetSysColor( %COLOR_INACTIVECAPTION ), GetSysColor( %COLOR_GRADIENTACTIVECAPTION ), GetSysColor( %COLOR_INACTIVECAPTIONTEXT ) )
End Sub

Sub SelectRow()
	Dim ht As Long
	Dim sel As Long
	Table_GetSelectRow( hTable, sel, ht )
	Table_SetSelectRow( hTable, 1, ht ): ' 1=Select row, 0=Select cell
End Sub
Sub SelectCell()
	Dim ht As Long
	Dim sel As Long
	Table_GetSelectRow( hTable, sel, ht )
	Table_SetSelectRow( hTable, 0, ht ): ' 1=Select row, 0=Select cell
End Sub

Sub HotTrack()
	Dim ht As Long
	Dim sel As Long
	Table_GetSelectRow( hTable, sel, ht )
	Table_SetSelectRow( hTable, sel, 1 ): ' 1=Select row, 0=Select cell
End Sub

Sub NoHotTrack()
	Dim ht As Long
	Dim sel As Long
	Table_GetSelectRow( hTable, sel, ht )
	Table_SetSelectRow( hTable, sel, 0 ): ' 1=Select row, 0=Select cell
End Sub

Sub Freeze2Rows1Col()
	Table_SetFrozen( hTable, 1, 2, 0 ): ' 1 row, 1 col, leave default color
End Sub

Sub Freeze2Cols1Row()
	Table_SetFrozen( hTable, 2, 1, 0 ): ' 1 row, 1 col, leave default color
End Sub

Sub FreezeNone()
	Table_SetFrozen( hTable, 0, 0, 0 ): ' 1 row, 1 col, leave default color
End Sub

Sub UserPaint()
	Table_SetUserPaint( hTable, CodePtr( Test_GridPaint ) ): ' Test painting
End Sub
Sub InternalPaint()
	Table_SetUserPaint( hTable, 0 ): ' Test painting
End Sub

Sub RowHeaders()
	Table_SetHeaders( hTable, 0, 1, 0 ): ' Turn off row and column headers
End Sub
Sub ColHeaders()
	Table_SetHeaders( hTable, 1, 0, 0 ): ' Turn off row and column headers
End Sub
Sub BothHeaders()
	Table_SetHeaders( hTable, 1, 1, 0 ): ' Turn off row and column headers
End Sub
Sub NoHeaders()
	Table_SetHeaders( hTable, 0, 0, 0 ): ' Turn off row and column headers
End Sub

Sub ThemedHeaders
	Table_SetStyle( hTable, %HeaderStyle.Themed, %HeaderStyle.Themed ): ' Themed, Button, Flat
End Sub
Sub ButtonHeaders
	Table_SetStyle( hTable, %HeaderStyle.Button, %HeaderStyle.Button ): ' Themed, Button, Flat
End Sub
Sub FlatHeaders
	Table_SetStyle( hTable, %HeaderStyle.Flat, %HeaderStyle.Flat ): ' Themed, Button, Flat
End Sub
Sub ThemedButtonHeaders
	Table_SetStyle( hTable, %HeaderStyle.Themed, %HeaderStyle.Button ): ' Themed, Button, Flat
End Sub



Sub AddString( ByVal hWnd As Dword, ByVal value As WString, ByVal proc As Dword )
	Local i As Long
	i = SendMessage( hWnd, %LB_ADDSTRING, 0, StrPtr(value) )
	SendMessage( hWnd, %LB_SETITEMDATA, i, proc )
End Sub

'============================================================================
' Get/Set Table data
'============================================================================
Sub Test_GetData( ByVal r As Long, ByVal c As Long, ByRef value As WString )
	If r<0 And c<0 Then
		value = ""
	ElseIf r<0 Then
		value = ""
		Do
			value = Chr$( 65 + (c Mod 26) ) + value
			c \= 26
		Loop While c
	ElseIf c<0 Then
		value = Format$(r+1, "0")
	Else
		value = Format$(r+1, "0")+"," + Format$(c+1, "0")
	End If
End Sub

Sub Test_GetArray( ByVal r As Long, ByVal c As Long, ByRef value As WString )
	Local cnt As Long
	Local v() As WString
	Local ch As WString
	If r<-1 Or r>=UBound( tlines() ) Then
		value = ""
		Exit Sub
	End If
	cnt = ParseCount( tLines(r+1), $Tab )
	ReDim v(cnt)
	Parse tLines(r+1), v(), $Tab
	If c<0 Or c>UBound(v()) Then
		value = ""
	Else
		value = v(c)
		If r>-1 Then
			Test_GetArray( -1, c, ch )
			If Left$(ch,5)="Sales" Then
				value = Format$( Val(v(c)), "#,##0.00" )
			End If
		End If
	End If
End Sub

' Note nothing uses this currently / no editing
Sub Test_SetData( ByVal r As Long, ByVal c As Long, ByRef value As WString )
End Sub

' Sample of user paint method
Function Test_GridPaint( ByVal part As Long, ByVal drwState As Long, ByRef value As WString, ByRef dta As DrawCellData ) As Long
	Function = 0: ' Everything else we didn't draw
	If part = %PaintPart.cellFore And dta.r=2 And dta.c=2 Then
		DrawText( dta.hdc, "OMG", 3, dta.rc, dta.align )
		Function = -1: ' Since we drew the foreground, say we did
	ElseIf part = %PaintPart.cellFore And dta.r = 4 And dta.c = 4 Then
		dta.foreColor = RGB( 192, 0, 0 ): ' Red text
		value = "XXXX"
	ElseIf part = %PaintPart.cellBack And (dta.r + dta.c) Mod 2 = 0 Then
		dta.backColor = RGB(247,232,185): ' Pale checkerboard
	End If
End Function

' Example WM_NOTIFY handling
Sub Window_OnNotify( ByVal hWnd As Dword, ByVal hPtr As NmHdr Ptr )
	Local ptbl As TblNotify Ptr
	If @hPtr.idFrom = %CTL_TABLE And @hPtr.code = %TBN_Select Then
		ptbl = hPtr
		SetWindowText hWNd, "Selected " + Format$( @ptbl.r + 1, "#,##0" ) + " : " + Format$( @ptbl.c+1, "#,##0" )
	ElseIf @hPtr.idFrom = %CTL_TABLE And @hPtr.code = %TBN_CellChg Then
		ptbl = hPtr
		SetWindowText hWNd, "Moved " + Format$( @ptbl.r+1, "#,##0" ) + " : " + Format$( @ptbl.c+1, "#,##0" )
	End If
End Sub
'============================================================================

'============================================================================
' SDK code to support main window
'============================================================================
Function WndProc( ByVal hWnd As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long
	Function = 0
	Select Case wMsg
		Case %WM_Command:         Call Window_OnCommand( hWnd, Lo(Word, wParam), Hi(Word, wParam), lParam ): Exit Function
		Case %WM_SysColorChange:  Call Window_OnSysColorChange( hWnd )
		Case %WM_Size:            Call Window_OnSize( hWnd )
		Case %WM_Destroy:         PostQuitMessage( 0 ): Exit Function
		Case %WM_Notify:          Call WIndow_OnNotify( hWnd, lParam ): Exit Function
		Case %WM_DrawItem:        Call Window_OnDrawItem( hWnd, lParam ): Function = %TRUE: Exit Function
	End Select
	Function = DefWindowProc( hWnd, wMsg, wParam, lParam )
End Function

Sub Window_OnDrawItem( ByVal hWnd As Dword, ByVal dis As DRAWITEMSTRUCT Ptr)
	Local buf As WStringZ * 50
	Local clr As Dword
	Local br As Dword
	Local fg As Dword

	fg = GetSysColor( %COLOR_WINDOWTEXT )
	SendMessage( @dis.hWndItem, %LB_GETText, @dis.itemId, ByVal VarPtr(buf) )
	If Mid$(buf,1,1)="-" Then
		clr = GetSysColor( %COLOR_BTNFACE )
	ElseIf (@dis.itemState And %ODS_SELECTED)<>0 Then
		clr = GetSysColor( %COLOR_HIGHLIGHT )
		fg = GetSysColor( %COLOR_HIGHLIGHTTEXT )
	Else
		clr = GetSysColor( %COLOR_WINDOW )
	End If
	If Mid$(buf,1,1)="-" Then
		DrawGradientBar( @dis.hdc, @dis.rcItem, GetSysColor( %COLOR_BTNHIGHLIGHT ), GetSysColor( %COLOR_BTNFACE ), -1 )
	Else
		br = CreateSolidBrush( clr )
		FillRect( @dis.hdc, @dis.rcItem, br )
		DeleteObject( br )
	End If

	SetBkMode( @dis.hdc, %TRANSPARENT )
	SetTextColor( @dis.hdc, fg )
	If (@dis.itemState And %ODS_SELECTED)<>0 Then
		DrawText( @dis.hdc, ">", 1, @dis.rcItem, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS )
	End If
	@dis.rcItem.Left += 10
	If Mid$(buf,1,1)="-" Then
		Local rc As RECT
		Local v As WString
		v = Mid$( buf, 2 )

		DrawText( @dis.hdc, ByVal StrPtr(v), Len(v), @dis.rcItem, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS )
		CopyRect( rc, @dis.rcItem )
		DrawText( @dis.hdc, ByVal StrPtr(v), Len(v), rc, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS Or %DT_CALCRECT )
		MoveTo( @dis.hdc, rc.Right+4, @dis.rcItem.top + (@dis.rcItem.Bottom-@dis.rcItem.Top)/2 )
		LineTo(  @dis.hdc, @dis.rcItem.Right-4, @dis.rcItem.top + (@dis.rcItem.Bottom-@dis.rcItem.Top)/2 )
	Else
		DrawText( @dis.hdc, buf, Len(buf), @dis.rcItem, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS )
	End If
End Sub

Sub Window_OnCommand( ByVal hWnd As Dword, ByVal ctlId As Long, ByVal nc As Dword, ByVal hLb As Dword )
	Local i As Long
	Local proc As Dword
	If ctlId = %CTL_LISTBOX And nc = %LBN_SelChange Then
		i = SendMessage( hLb, %LB_GetCurSel, 0, 0 )
		If i<>%LB_ERR Then
			proc = SendMessage( hLb, %LB_GetItemData, i, 0 )
			If proc<>%LB_ERR And proc Then
				Call Dword proc
			End If
		End If
	End If
End Sub

Sub Window_OnSysColorChange( ByVal hWnd As Dword )
	Call EnumChildWindows( hWnd,  CodePtr( Window_SysColorChange ), 0 ): ' Ensure child controls know of change
End Sub

Function Window_SysColorChange( ByVal hWnd As Dword, ByVal lParam As Long ) As Long
	SendMessage( hWnd, %WM_SYSCOLORCHANGE, 0, 0 )
	Function = %TRUE
End Function

Sub Window_OnSize( ByVal hWnd As Dword )
	Local rc As RECT
	Local hChild As Dword

	GetClientRect( hWnd, rc )

	hChild = GetDlgItem( hWnd, %CTL_LISTBOX )
	SetWindowPos( hChild,  0, 0, 0, %LIST_WIDTH, rc.Bottom, %SWP_NOMOVE Or %SWP_NOZORDER )

	hChild = GetDlgItem( hWnd, %CTL_TABLE )
	SetWindowPos( hChild,  0, %LIST_WIDTH, 0, rc.Right-%LIST_WIDTH, rc.Bottom, %SWP_NOMOVE Or %SWP_NOZORDER )
End Sub

Sub Initialize()
	Static init As Long
	Dim wc As WNDCLASS
	Dim className As WStringZ*40

	If init Then Exit Sub: ' Already initialized

	' Register class for Overlapped window
	className = $WIN_CLASS
	wc.style = 0
	wc.lpfnWndProc = CodePtr( WndProc )
	wc.cbClsExtra = 0
	wc.cbWndExtra = 0
	wc.hInstance = GetModuleHandle(ByVal 0)
	wc.hIcon = LoadIcon(%NULL, ByVal %IDI_APPLICATION)
	wc.hCursor = LoadCursor(%NULL, ByVal %IDC_ARROW)
	wc.hbrBackground = GetSysColorBrush( %COLOR_WINDOW )
	wc.lpszMenuName =  0
	wc.lpszClassName = VarPtr(className)

	RegisterClass( wc )
	init = -1
End Sub

Function SystemError() Common As WString
		Local errorCode As Dword
		Local buffer As WStringZ * 512
		errorCode = GetLastError()
		FormatMessage( %FORMAT_MESSAGE_FROM_SYSTEM, ByVal %NULL, errorCode, %NULL, buffer, SizeOf(buffer), ByVal %NULL )
		Function = buffer
End Function

Function Run() As Long
	Local msg As tagMSG
	Local hWnd As Dword
	While GetMessage( msg, %NULL, 0, 0 ) > 0
		hWnd = msg.hwnd
		While (GetWindowLong( hWnd, %GWL_STYLE) And %WS_Child)<>0
			hWnd = GetParent( hWnd )
		Wend
		If IsDialogMessage( hWnd, msg ) = 0 Then
			TranslateMessage( msg )
			DispatchMessage( msg )
		End If
	Wend
End Function
